/* flip.c generated by valac 0.17.2, the Vala compiler
 * generated from flip.vala, do not modify */

/*  Mutiara motif designer.
Copyright (C) 2011  Nor Jaidi Tuah

This file is part of Mutiara.

Mutiara is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>


#define TYPE_FLIP (flip_get_type ())

#define TYPE_TWEAK (tweak_get_type ())
typedef struct _Tweak Tweak;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_TWEAK_WIDGET (tweak_widget_get_type ())
#define TWEAK_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWEAK_WIDGET, TweakWidget))
#define TWEAK_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWEAK_WIDGET, TweakWidgetClass))
#define IS_TWEAK_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWEAK_WIDGET))
#define IS_TWEAK_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWEAK_WIDGET))
#define TWEAK_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWEAK_WIDGET, TweakWidgetClass))

typedef struct _TweakWidget TweakWidget;
typedef struct _TweakWidgetClass TweakWidgetClass;
typedef struct _TweakWidgetPrivate TweakWidgetPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

typedef enum  {
	FLIP_NONE = 0,
	FLIP_Y = 1,
	FLIP_X = 2,
	FLIP_XY = 3
} Flip;

struct _Tweak {
	gdouble scale_x;
	gdouble scale_y;
	gdouble rotate;
	gdouble move_x;
	gdouble move_y;
};

struct _TweakWidget {
	GtkButton parent_instance;
	TweakWidgetPrivate * priv;
};

struct _TweakWidgetClass {
	GtkButtonClass parent_class;
};

struct _TweakWidgetPrivate {
	Flip* flip;
	gint flip_length1;
	gint _flip_size_;
	Tweak tweak;
	GtkDrawingArea* icon;
	Flip* flip_save;
	gint flip_save_length1;
	gint _flip_save_size_;
	Tweak tweak_save;
	gboolean full_tweak;
	gboolean ready;
	GtkDialog* dialog;
	GtkDrawingArea* segment_view;
	GtkSpinButton* scale_x_entry;
	GtkSpinButton* scale_y_entry;
	GtkSpinButton* rotate_entry;
	GtkSpinButton* move_x_entry;
	GtkSpinButton* move_y_entry;
	Flip* dialog_flip;
	gint dialog_flip_length1;
	gint _dialog_flip_size_;
	Tweak dialog_tweak;
	GtkToggleButton** toggle;
	gint toggle_length1;
	gint toggle_length2;
	gint num_bits;
};

struct _Block1Data {
	int _ref_count_;
	TweakWidget * self;
	gint gap;
	gint size;
};

typedef void (*UtilContentsDelegate) (GtkGrid* grid, void* user_data);
struct _Block2Data {
	int _ref_count_;
	TweakWidget * self;
	gint gap;
	gint size;
};

struct _Block3Data {
	int _ref_count_;
	TweakWidget * self;
	GtkToggleButton* button;
	gint size;
	gint segment;
	gint bit;
};


static gpointer tweak_widget_parent_class = NULL;

GType flip_get_type (void) G_GNUC_CONST;
gboolean flip_x (Flip self);
gboolean flip_y (Flip self);
gboolean flip_is_set (Flip self, gint bit);
Flip flip_set (Flip self, gint bit);
Flip flip_clear (Flip self, gint bit);
GType tweak_get_type (void) G_GNUC_CONST;
Tweak* tweak_dup (const Tweak* self);
void tweak_free (Tweak* self);
void tweak_init (Tweak *self);
gboolean tweak_equals (Tweak *self, Tweak* t);
gchar* tweak_serialize (Tweak *self);
gchar* util_format (gdouble n, gint decimal_places);
GType tweak_widget_get_type (void) G_GNUC_CONST;
#define TWEAK_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TWEAK_WIDGET, TweakWidgetPrivate))
enum  {
	TWEAK_WIDGET_DUMMY_PROPERTY
};
TweakWidget* tweak_widget_new (gboolean full_tweak);
TweakWidget* tweak_widget_construct (GType object_type, gboolean full_tweak);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda2_ (Block1Data* _data1_, cairo_t* cr);
static void tweak_widget_draw_segment (TweakWidget* self, cairo_t* cr, Tweak* tweak, Flip flip, gdouble x, gdouble y, gdouble size);
static gboolean ___lambda2__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static void __lambda3_ (TweakWidget* self);
static void ___lambda3__tweak_widget_tweaked (TweakWidget* _sender, gpointer self);
static void __lambda4_ (TweakWidget* self);
static void tweak_widget_show_dialog (TweakWidget* self);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender, gpointer self);
void tweak_widget_set_tweaks (TweakWidget* self, Tweak* t, Flip flip0, Flip flip1);
void tweak_widget_get_tweaks (TweakWidget* self, Tweak* t, Flip* flip0, Flip* flip1);
static void tweak_widget_make_dialog (TweakWidget* self);
GtkDialog* util_make_dialog (const gchar* title, const gchar* ok_text, UtilContentsDelegate put_contents, void* put_contents_target);
static void __lambda5_ (TweakWidget* self, GtkGrid* grid);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static GtkWidget* tweak_widget_create_tweak_entries (TweakWidget* self);
static gboolean __lambda9_ (Block2Data* _data2_, cairo_t* cr);
static gboolean ___lambda9__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static GtkToggleButton* tweak_widget_create_button (TweakWidget* self, gint segment, gint bit);
static void ___lambda5__util_contents_delegate (GtkGrid* grid, gpointer self);
static void tweak_widget_attach_entry (TweakWidget* self, GtkGrid* grid, gint y, const gchar* label_text, GtkSpinButton** buttons, int buttons_length1);
GtkSpinButton* util_make_spin_button (gdouble min, gdouble max, gdouble step);
GtkLabel* util_label (const gchar* label_text);
static void ____lambda6_ (TweakWidget* self);
static void _____lambda6__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda10_ (Block3Data* _data3_, cairo_t* cr);
static gboolean ___lambda10__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static void __lambda11_ (Block3Data* _data3_);
static void ___lambda11__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void tweak_widget_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gboolean flip_x (Flip self) {
	gboolean result = FALSE;
#line 26 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = (self & FLIP_X) == FLIP_X;
#line 26 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 200 "flip.c"
}


gboolean flip_y (Flip self) {
	gboolean result = FALSE;
#line 30 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = (self & FLIP_Y) == FLIP_Y;
#line 30 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 210 "flip.c"
}


/**
 * bit: 0 => y, 1 => x
 */
gboolean flip_is_set (Flip self, gint bit) {
	gboolean result = FALSE;
	gint _tmp0_;
#line 37 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = bit;
#line 37 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = (self & (1 << _tmp0_)) != 0;
#line 37 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 226 "flip.c"
}


Flip flip_set (Flip self, gint bit) {
	Flip result = 0;
	gint _tmp0_;
#line 41 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = bit;
#line 41 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = self | (1 << _tmp0_);
#line 41 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 239 "flip.c"
}


Flip flip_clear (Flip self, gint bit) {
	Flip result = 0;
	gint _tmp0_;
#line 45 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = bit;
#line 45 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = self & (~(1 << _tmp0_));
#line 45 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 252 "flip.c"
}


GType flip_get_type (void) {
	static volatile gsize flip_type_id__volatile = 0;
	if (g_once_init_enter (&flip_type_id__volatile)) {
		static const GEnumValue values[] = {{FLIP_NONE, "FLIP_NONE", "none"}, {FLIP_Y, "FLIP_Y", "y"}, {FLIP_X, "FLIP_X", "x"}, {FLIP_XY, "FLIP_XY", "xy"}, {0, NULL, NULL}};
		GType flip_type_id;
		flip_type_id = g_enum_register_static ("Flip", values);
		g_once_init_leave (&flip_type_id__volatile, flip_type_id);
	}
	return flip_type_id__volatile;
}


void tweak_init (Tweak *self) {
#line 56 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	memset (self, 0, sizeof (Tweak));
#line 57 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	(*self).scale_x = (gdouble) 1;
#line 58 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	(*self).scale_y = (gdouble) 1;
#line 59 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	(*self).rotate = (gdouble) 0;
#line 60 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	(*self).move_x = (gdouble) 0;
#line 61 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	(*self).move_y = (gdouble) 0;
#line 281 "flip.c"
}


gboolean tweak_equals (Tweak *self, Tweak* t) {
	gboolean result = FALSE;
	gdouble epsilon;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gdouble _tmp4_;
	Tweak _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gboolean _tmp14_;
	gboolean _tmp20_;
	gboolean _tmp26_;
	gboolean _tmp32_;
#line 64 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_val_if_fail (t != NULL, FALSE);
#line 65 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	epsilon = 0.00001;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = (*self).scale_x;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = *t;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = _tmp5_.scale_x;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = fabs (_tmp4_ - _tmp6_);
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = epsilon;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp7_ < _tmp8_) {
#line 317 "flip.c"
		gdouble _tmp9_;
		Tweak _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_;
#line 68 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp9_ = (*self).scale_y;
#line 68 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp10_ = *t;
#line 68 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp11_ = _tmp10_.scale_y;
#line 68 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp12_ = fabs (_tmp9_ - _tmp11_);
#line 68 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp13_ = epsilon;
#line 68 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = _tmp12_ < _tmp13_;
#line 335 "flip.c"
	} else {
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = FALSE;
#line 339 "flip.c"
	}
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = _tmp3_;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp14_) {
#line 345 "flip.c"
		gdouble _tmp15_;
		Tweak _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_;
#line 69 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp15_ = (*self).rotate;
#line 69 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp16_ = *t;
#line 69 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp17_ = _tmp16_.rotate;
#line 69 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp18_ = fabs (_tmp15_ - _tmp17_);
#line 69 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp19_ = epsilon;
#line 69 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp2_ = _tmp18_ < _tmp19_;
#line 363 "flip.c"
	} else {
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp2_ = FALSE;
#line 367 "flip.c"
	}
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp20_ = _tmp2_;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp20_) {
#line 373 "flip.c"
		gdouble _tmp21_;
		Tweak _tmp22_;
		gdouble _tmp23_;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_;
#line 70 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp21_ = (*self).move_x;
#line 70 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp22_ = *t;
#line 70 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp23_ = _tmp22_.move_x;
#line 70 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp24_ = fabs (_tmp21_ - _tmp23_);
#line 70 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp25_ = epsilon;
#line 70 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp1_ = _tmp24_ < _tmp25_;
#line 391 "flip.c"
	} else {
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp1_ = FALSE;
#line 395 "flip.c"
	}
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp26_ = _tmp1_;
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp26_) {
#line 401 "flip.c"
		gdouble _tmp27_;
		Tweak _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_;
#line 71 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp27_ = (*self).move_y;
#line 71 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp28_ = *t;
#line 71 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp29_ = _tmp28_.move_y;
#line 71 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp30_ = fabs (_tmp27_ - _tmp29_);
#line 71 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp31_ = epsilon;
#line 71 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = _tmp30_ < _tmp31_;
#line 419 "flip.c"
	} else {
#line 67 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = FALSE;
#line 423 "flip.c"
	}
#line 66 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp32_ = _tmp0_;
#line 66 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = _tmp32_;
#line 66 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 431 "flip.c"
}


gchar* tweak_serialize (Tweak *self) {
	gchar* result = NULL;
	gdouble _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gdouble _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gdouble _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_;
	gdouble _tmp12_;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = (*self).scale_x;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = util_format (_tmp0_, 3);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = _tmp1_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = (*self).scale_y;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = util_format (_tmp3_, 3);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = _tmp4_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = (*self).rotate;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = util_format (_tmp6_, 1);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = _tmp7_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = (*self).move_x;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = util_format (_tmp9_, 3);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = _tmp10_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = (*self).move_y;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = util_format (_tmp12_, 3);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = _tmp13_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = g_strdup_printf ("%s %s,  %s,  %s %s", _tmp2_, _tmp5_, _tmp8_, _tmp11_, _tmp14_);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = _tmp15_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_free0 (_tmp14_);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_free0 (_tmp11_);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_free0 (_tmp8_);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_free0 (_tmp5_);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_free0 (_tmp2_);
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = _tmp16_;
#line 75 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 502 "flip.c"
}


Tweak* tweak_dup (const Tweak* self) {
	Tweak* dup;
#line 49 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	dup = g_new0 (Tweak, 1);
#line 49 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	memcpy (dup, self, sizeof (Tweak));
#line 49 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return dup;
#line 514 "flip.c"
}


void tweak_free (Tweak* self) {
#line 49 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_free (self);
#line 521 "flip.c"
}


GType tweak_get_type (void) {
	static volatile gsize tweak_type_id__volatile = 0;
	if (g_once_init_enter (&tweak_type_id__volatile)) {
		GType tweak_type_id;
		tweak_type_id = g_boxed_type_register_static ("Tweak", (GBoxedCopyFunc) tweak_dup, (GBoxedFreeFunc) tweak_free);
		g_once_init_leave (&tweak_type_id__volatile, tweak_type_id);
	}
	return tweak_type_id__volatile;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return _data1_;
#line 541 "flip.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 550 "flip.c"
		TweakWidget * self;
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		self = _data1_->self;
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_g_object_unref0 (self);
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		g_slice_free (Block1Data, _data1_);
#line 558 "flip.c"
	}
}


static gboolean __lambda2_ (Block1Data* _data1_, cairo_t* cr) {
	TweakWidget * self;
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	Tweak _tmp1_;
	Flip* _tmp2_;
	gint _tmp2__length1;
	Flip _tmp3_;
	cairo_t* _tmp4_;
	Tweak _tmp5_;
	Flip* _tmp6_;
	gint _tmp6__length1;
	Flip _tmp7_;
#line 136 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self = _data1_->self;
#line 136 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 137 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = cr;
#line 137 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = self->priv->tweak;
#line 137 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = self->priv->flip;
#line 137 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2__length1 = self->priv->flip_length1;
#line 137 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = _tmp2_[0];
#line 137 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_draw_segment (self, _tmp0_, &_tmp1_, _tmp3_, (gdouble) _data1_->gap, (gdouble) _data1_->gap, (gdouble) _data1_->size);
#line 138 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = cr;
#line 138 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = self->priv->tweak;
#line 138 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = self->priv->flip;
#line 138 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6__length1 = self->priv->flip_length1;
#line 138 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = _tmp6_[1];
#line 138 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_draw_segment (self, _tmp4_, &_tmp5_, _tmp7_, (gdouble) (_data1_->gap + _data1_->size), (gdouble) _data1_->gap, (gdouble) _data1_->size);
#line 139 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = TRUE;
#line 139 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 608 "flip.c"
}


static gboolean ___lambda2__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = __lambda2_ (self, cr);
#line 136 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 617 "flip.c"
}


static void __lambda3_ (TweakWidget* self) {
	GtkDrawingArea* _tmp0_;
#line 141 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = self->priv->icon;
#line 141 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 627 "flip.c"
}


static void ___lambda3__tweak_widget_tweaked (TweakWidget* _sender, gpointer self) {
#line 141 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	__lambda3_ (self);
#line 634 "flip.c"
}


static void __lambda4_ (TweakWidget* self) {
#line 142 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_show_dialog (self);
#line 641 "flip.c"
}


static void ___lambda4__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 142 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	__lambda4_ (self);
#line 648 "flip.c"
}


TweakWidget* tweak_widget_construct (GType object_type, gboolean full_tweak) {
	TweakWidget * self = NULL;
	Block1Data* _data1_;
	Flip* _tmp0_ = NULL;
	gboolean _tmp1_;
	GtkDrawingArea* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkDrawingArea* _tmp4_;
	GtkDrawingArea* _tmp5_;
	GtkDrawingArea* _tmp6_;
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data1_->_ref_count_ = 1;
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self = (TweakWidget*) g_object_new (object_type, NULL);
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data1_->self = g_object_ref (self);
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = g_new0 (Flip, 2);
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_[0] = FLIP_NONE;
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_[1] = FLIP_Y;
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip = (g_free (self->priv->flip), NULL);
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip = _tmp0_;
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip_length1 = 2;
#line 128 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->_flip_size_ = self->priv->flip_length1;
#line 129 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = full_tweak;
#line 129 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->full_tweak = _tmp1_;
#line 130 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_init (&self->priv->tweak);
#line 131 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 131 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_object_ref_sink (_tmp2_);
#line 131 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->icon);
#line 131 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->icon = _tmp2_;
#line 131 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = self->priv->icon;
#line 131 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp3_);
#line 132 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data1_->gap = 4;
#line 133 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data1_->size = 20;
#line 134 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = self->priv->icon;
#line 134 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp4_, (_data1_->size + _data1_->gap) * 2, _data1_->size + (_data1_->gap * 2));
#line 135 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = self->priv->icon;
#line 135 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_has_window ((GtkWidget*) _tmp5_, FALSE);
#line 136 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = self->priv->icon;
#line 136 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_connect_data ((GtkWidget*) _tmp6_, "draw", (GCallback) ___lambda2__gtk_widget_draw, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 141 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_connect_object (self, "tweaked", (GCallback) ___lambda3__tweak_widget_tweaked, self, 0);
#line 142 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	block1_data_unref (_data1_);
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data1_ = NULL;
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return self;
#line 728 "flip.c"
}


TweakWidget* tweak_widget_new (gboolean full_tweak) {
#line 127 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return tweak_widget_construct (TYPE_TWEAK_WIDGET, full_tweak);
#line 735 "flip.c"
}


void tweak_widget_set_tweaks (TweakWidget* self, Tweak* t, Flip flip0, Flip flip1) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Flip _tmp2_;
	Flip* _tmp3_;
	gint _tmp3__length1;
	Flip _tmp4_;
	gboolean _tmp8_;
	gboolean _tmp11_;
#line 145 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (self != NULL);
#line 145 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (t != NULL);
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = flip0;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = self->priv->flip;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3__length1 = self->priv->flip_length1;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = _tmp3_[0];
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp2_ != _tmp4_) {
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp1_ = TRUE;
#line 764 "flip.c"
	} else {
		Flip _tmp5_;
		Flip* _tmp6_;
		gint _tmp6__length1;
		Flip _tmp7_;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp5_ = flip1;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp6_ = self->priv->flip;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp6__length1 = self->priv->flip_length1;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp7_ = _tmp6_[1];
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp1_ = _tmp5_ != _tmp7_;
#line 780 "flip.c"
	}
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = _tmp1_;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp8_) {
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = TRUE;
#line 788 "flip.c"
	} else {
		Tweak _tmp9_;
		gboolean _tmp10_ = FALSE;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp9_ = *t;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp10_ = tweak_equals (&self->priv->tweak, &_tmp9_);
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = !_tmp10_;
#line 798 "flip.c"
	}
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = _tmp0_;
#line 146 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp11_) {
#line 804 "flip.c"
		Flip* _tmp12_;
		gint _tmp12__length1;
		Flip _tmp13_;
		Flip _tmp14_;
		Flip* _tmp15_;
		gint _tmp15__length1;
		Flip _tmp16_;
		Flip _tmp17_;
		gboolean _tmp18_;
#line 147 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp12_ = self->priv->flip;
#line 147 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp12__length1 = self->priv->flip_length1;
#line 147 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp13_ = flip0;
#line 147 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp12_[0] = _tmp13_;
#line 147 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp14_ = _tmp12_[0];
#line 148 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp15_ = self->priv->flip;
#line 148 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp15__length1 = self->priv->flip_length1;
#line 148 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp16_ = flip1;
#line 148 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp15_[1] = _tmp16_;
#line 148 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp17_ = _tmp15_[1];
#line 149 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp18_ = self->priv->full_tweak;
#line 149 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		if (_tmp18_) {
#line 838 "flip.c"
			Tweak _tmp19_;
#line 149 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			_tmp19_ = *t;
#line 149 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			self->priv->tweak = _tmp19_;
#line 844 "flip.c"
		}
#line 150 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		g_signal_emit_by_name (self, "tweaked");
#line 848 "flip.c"
	}
}


void tweak_widget_get_tweaks (TweakWidget* self, Tweak* t, Flip* flip0, Flip* flip1) {
	Flip _vala_flip0 = 0;
	Flip _vala_flip1 = 0;
	Flip* _tmp0_;
	gint _tmp0__length1;
	Flip _tmp1_;
	Flip* _tmp2_;
	gint _tmp2__length1;
	Flip _tmp3_;
	gboolean _tmp4_;
#line 154 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (self != NULL);
#line 154 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (t != NULL);
#line 155 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = self->priv->flip;
#line 155 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0__length1 = self->priv->flip_length1;
#line 155 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = _tmp0_[0];
#line 155 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_vala_flip0 = _tmp1_;
#line 156 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = self->priv->flip;
#line 156 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2__length1 = self->priv->flip_length1;
#line 156 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = _tmp2_[1];
#line 156 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_vala_flip1 = _tmp3_;
#line 157 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = self->priv->full_tweak;
#line 157 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp4_) {
#line 887 "flip.c"
		Tweak _tmp5_;
#line 157 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp5_ = self->priv->tweak;
#line 157 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		*t = _tmp5_;
#line 893 "flip.c"
	}
#line 154 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (flip0) {
#line 154 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		*flip0 = _vala_flip0;
#line 899 "flip.c"
	}
#line 154 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (flip1) {
#line 154 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		*flip1 = _vala_flip1;
#line 905 "flip.c"
	}
}


static void tweak_widget_show_dialog (TweakWidget* self) {
	GtkDialog* _tmp0_;
	gboolean _tmp1_;
	Flip* _tmp41_;
	gint _tmp41__length1;
	Flip _tmp42_;
	Flip* _tmp43_;
	gint _tmp43__length1;
	Flip _tmp44_;
	Flip* _tmp45_ = NULL;
	Tweak _tmp46_;
	GtkDialog* _tmp47_;
	gint _tmp48_ = 0;
	gint _result_;
	GtkDialog* _tmp49_;
	gint _tmp50_;
#line 160 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (self != NULL);
#line 161 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->ready = FALSE;
#line 162 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = self->priv->dialog;
#line 162 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp0_ == NULL) {
#line 162 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		tweak_widget_make_dialog (self);
#line 936 "flip.c"
	}
#line 164 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = self->priv->full_tweak;
#line 164 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp1_) {
#line 942 "flip.c"
		GtkSpinButton* _tmp2_;
		Tweak _tmp3_;
		gdouble _tmp4_;
		GtkSpinButton* _tmp5_;
		Tweak _tmp6_;
		gdouble _tmp7_;
		GtkSpinButton* _tmp8_;
		Tweak _tmp9_;
		gdouble _tmp10_;
		GtkSpinButton* _tmp11_;
		Tweak _tmp12_;
		gdouble _tmp13_;
		GtkSpinButton* _tmp14_;
		Tweak _tmp15_;
		gdouble _tmp16_;
#line 165 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp2_ = self->priv->scale_x_entry;
#line 165 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = self->priv->tweak;
#line 165 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp4_ = _tmp3_.scale_x;
#line 165 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_spin_button_set_value (_tmp2_, _tmp4_);
#line 166 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp5_ = self->priv->scale_y_entry;
#line 166 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp6_ = self->priv->tweak;
#line 166 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp7_ = _tmp6_.scale_y;
#line 166 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_spin_button_set_value (_tmp5_, _tmp7_);
#line 167 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp8_ = self->priv->rotate_entry;
#line 167 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp9_ = self->priv->tweak;
#line 167 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp10_ = _tmp9_.rotate;
#line 167 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_spin_button_set_value (_tmp8_, _tmp10_);
#line 168 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp11_ = self->priv->move_x_entry;
#line 168 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp12_ = self->priv->tweak;
#line 168 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp13_ = _tmp12_.move_x;
#line 168 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_spin_button_set_value (_tmp11_, _tmp13_);
#line 169 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp14_ = self->priv->move_y_entry;
#line 169 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp15_ = self->priv->tweak;
#line 169 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp16_ = _tmp15_.move_y;
#line 169 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_spin_button_set_value (_tmp14_, _tmp16_);
#line 998 "flip.c"
	}
	{
		gint seg;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		seg = 0;
#line 1004 "flip.c"
		{
			gboolean _tmp17_;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			_tmp17_ = TRUE;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			while (TRUE) {
#line 1011 "flip.c"
				gboolean _tmp18_;
				gint _tmp20_;
				Flip* _tmp21_;
				gint _tmp21__length1;
				gint _tmp22_;
				Flip* _tmp23_;
				gint _tmp23__length1;
				gint _tmp24_;
				Flip _tmp25_;
				Flip _tmp26_;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp18_ = _tmp17_;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				if (!_tmp18_) {
#line 1026 "flip.c"
					gint _tmp19_;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					_tmp19_ = seg;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					seg = _tmp19_ + 1;
#line 1032 "flip.c"
				}
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp17_ = FALSE;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp20_ = seg;
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				if (!(_tmp20_ < 2)) {
#line 172 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					break;
#line 1042 "flip.c"
				}
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp21_ = self->priv->dialog_flip;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp21__length1 = self->priv->dialog_flip_length1;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp22_ = seg;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp23_ = self->priv->flip;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp23__length1 = self->priv->flip_length1;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp24_ = seg;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp25_ = _tmp23_[_tmp24_];
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp21_[_tmp22_] = _tmp25_;
#line 173 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp26_ = _tmp21_[_tmp22_];
#line 1062 "flip.c"
				{
					gint bit;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					bit = 0;
#line 1067 "flip.c"
					{
						gboolean _tmp27_;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
						_tmp27_ = TRUE;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
						while (TRUE) {
#line 1074 "flip.c"
							gboolean _tmp28_;
							gint _tmp30_;
							gint _tmp31_;
							GtkToggleButton** _tmp32_;
							gint _tmp32__length1;
							gint _tmp32__length2;
							gint _tmp33_;
							gint _tmp34_;
							GtkToggleButton* _tmp35_;
							Flip* _tmp36_;
							gint _tmp36__length1;
							gint _tmp37_;
							Flip _tmp38_;
							gint _tmp39_;
							gboolean _tmp40_ = FALSE;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp28_ = _tmp27_;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							if (!_tmp28_) {
#line 1094 "flip.c"
								gint _tmp29_;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
								_tmp29_ = bit;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
								bit = _tmp29_ + 1;
#line 1100 "flip.c"
							}
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp27_ = FALSE;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp30_ = bit;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp31_ = self->priv->num_bits;
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							if (!(_tmp30_ < _tmp31_)) {
#line 174 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
								break;
#line 1112 "flip.c"
							}
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp32_ = self->priv->toggle;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp32__length1 = self->priv->toggle_length1;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp32__length2 = self->priv->toggle_length2;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp33_ = seg;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp34_ = bit;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp35_ = _tmp32_[(_tmp33_ * _tmp32__length2) + _tmp34_];
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp36_ = self->priv->dialog_flip;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp36__length1 = self->priv->dialog_flip_length1;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp37_ = seg;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp38_ = _tmp36_[_tmp37_];
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp39_ = bit;
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp40_ = flip_is_set (_tmp38_, _tmp39_);
#line 175 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							gtk_toggle_button_set_active (_tmp35_, _tmp40_);
#line 1140 "flip.c"
						}
					}
				}
			}
		}
	}
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp41_ = self->priv->flip;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp41__length1 = self->priv->flip_length1;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp42_ = _tmp41_[0];
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp43_ = self->priv->flip;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp43__length1 = self->priv->flip_length1;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp44_ = _tmp43_[1];
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp45_ = g_new0 (Flip, 2);
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp45_[0] = _tmp42_;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp45_[1] = _tmp44_;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip_save = (g_free (self->priv->flip_save), NULL);
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip_save = _tmp45_;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip_save_length1 = 2;
#line 179 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->_flip_save_size_ = self->priv->flip_save_length1;
#line 180 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp46_ = self->priv->tweak;
#line 180 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->tweak_save = _tmp46_;
#line 181 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->ready = TRUE;
#line 182 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp47_ = self->priv->dialog;
#line 182 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp48_ = gtk_dialog_run (_tmp47_);
#line 182 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_result_ = _tmp48_;
#line 183 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp49_ = self->priv->dialog;
#line 183 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_hide ((GtkWidget*) _tmp49_);
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp50_ = _result_;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp50_ != ((gint) GTK_RESPONSE_OK)) {
#line 1193 "flip.c"
		Tweak _tmp51_;
		Flip* _tmp52_;
		gint _tmp52__length1;
		Flip _tmp53_;
		Flip* _tmp54_;
		gint _tmp54__length1;
		Flip _tmp55_;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp51_ = self->priv->tweak_save;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp52_ = self->priv->flip_save;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp52__length1 = self->priv->flip_save_length1;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp53_ = _tmp52_[0];
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp54_ = self->priv->flip_save;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp54__length1 = self->priv->flip_save_length1;
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp55_ = _tmp54_[1];
#line 184 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		tweak_widget_set_tweaks (self, &_tmp51_, _tmp53_, _tmp55_);
#line 1217 "flip.c"
	}
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return _data2_;
#line 1227 "flip.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1236 "flip.c"
		TweakWidget * self;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		self = _data2_->self;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_g_object_unref0 (self);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		g_slice_free (Block2Data, _data2_);
#line 1244 "flip.c"
	}
}


static gboolean __lambda9_ (Block2Data* _data2_, cairo_t* cr) {
	TweakWidget * self;
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	Tweak _tmp1_;
	Flip* _tmp2_;
	gint _tmp2__length1;
	Flip _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	cairo_t* _tmp7_;
	Tweak _tmp8_;
	Flip* _tmp9_;
	gint _tmp9__length1;
	Flip _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 203 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self = _data2_->self;
#line 203 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = cr;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = self->priv->dialog_tweak;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = self->priv->dialog_flip;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2__length1 = self->priv->dialog_flip_length1;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = _tmp2_[0];
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = _data2_->gap;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = _data2_->gap;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = _data2_->size;
#line 204 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_draw_segment (self, _tmp0_, &_tmp1_, _tmp3_, (gdouble) _tmp4_, (gdouble) _tmp5_, (gdouble) _tmp6_);
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = cr;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = self->priv->dialog_tweak;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = self->priv->dialog_flip;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9__length1 = self->priv->dialog_flip_length1;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = _tmp9_[1];
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = _data2_->gap;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = _data2_->size;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = _data2_->gap;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = _data2_->size;
#line 205 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_draw_segment (self, _tmp7_, &_tmp8_, _tmp10_, (gdouble) (_tmp11_ + _tmp12_), (gdouble) _tmp13_, (gdouble) _tmp14_);
#line 206 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = TRUE;
#line 206 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 1315 "flip.c"
}


static gboolean ___lambda9__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = __lambda9_ (self, cr);
#line 203 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 1324 "flip.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return self ? g_object_ref (self) : NULL;
#line 1331 "flip.c"
}


static void __lambda5_ (TweakWidget* self, GtkGrid* grid) {
	Block2Data* _data2_;
	Flip* _tmp0_ = NULL;
	gboolean _tmp1_;
	GtkDrawingArea* _tmp5_;
	GtkGrid* _tmp6_;
	GtkDrawingArea* _tmp7_;
	gint _tmp8_;
	GtkDrawingArea* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkDrawingArea* _tmp14_;
	GtkDrawingArea* _tmp15_;
	GtkDrawingArea* _tmp16_;
	GtkDrawingArea* _tmp17_;
	gint _tmp18_;
	GtkToggleButton** _tmp19_ = NULL;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (grid != NULL);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data2_->_ref_count_ = 1;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data2_->self = g_object_ref (self);
#line 189 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = g_new0 (Flip, 2);
#line 189 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_flip = (g_free (self->priv->dialog_flip), NULL);
#line 189 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_flip = _tmp0_;
#line 189 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_flip_length1 = 2;
#line 189 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->_dialog_flip_size_ = self->priv->dialog_flip_length1;
#line 190 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_init (&self->priv->dialog_tweak);
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = self->priv->full_tweak;
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp1_) {
#line 1378 "flip.c"
		GtkGrid* _tmp2_;
		GtkWidget* _tmp3_ = NULL;
		GtkWidget* _tmp4_;
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp2_ = grid;
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = tweak_widget_create_tweak_entries (self);
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp4_ = _tmp3_;
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_grid_attach (_tmp2_, _tmp4_, 0, 0, 3, 1);
#line 192 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_g_object_unref0 (_tmp4_);
#line 1392 "flip.c"
	}
#line 195 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 195 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_object_ref_sink (_tmp5_);
#line 195 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->segment_view);
#line 195 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->segment_view = _tmp5_;
#line 196 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = grid;
#line 196 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = self->priv->segment_view;
#line 196 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = self->priv->num_bits;
#line 196 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp7_, 1, 1, 1, _tmp8_);
#line 197 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data2_->gap = 10;
#line 198 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data2_->size = 50;
#line 199 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = self->priv->segment_view;
#line 199 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = _data2_->size;
#line 199 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = _data2_->gap;
#line 199 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = _data2_->size;
#line 199 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = _data2_->gap;
#line 199 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp9_, (_tmp10_ + _tmp11_) * 2, _tmp12_ + (_tmp13_ * 2));
#line 200 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = self->priv->segment_view;
#line 200 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_has_window ((GtkWidget*) _tmp14_, FALSE);
#line 201 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = self->priv->segment_view;
#line 201 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
#line 202 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = self->priv->segment_view;
#line 202 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
#line 203 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp17_ = self->priv->segment_view;
#line 203 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_connect_data ((GtkWidget*) _tmp17_, "draw", (GCallback) ___lambda9__gtk_widget_draw, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 210 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp18_ = self->priv->num_bits;
#line 210 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp19_ = g_new0 (GtkToggleButton*, (2 * _tmp18_) + 1);
#line 210 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->toggle = (_vala_array_free (self->priv->toggle, self->priv->toggle_length1 * self->priv->toggle_length2, (GDestroyNotify) g_object_unref), NULL);
#line 210 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->toggle = _tmp19_;
#line 210 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->toggle_length1 = 2;
#line 210 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->toggle_length2 = _tmp18_;
#line 1454 "flip.c"
	{
		gint seg;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		seg = 0;
#line 1459 "flip.c"
		{
			gboolean _tmp20_;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			_tmp20_ = TRUE;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			while (TRUE) {
#line 1466 "flip.c"
				gboolean _tmp21_;
				gint _tmp23_;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp21_ = _tmp20_;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				if (!_tmp21_) {
#line 1473 "flip.c"
					gint _tmp22_;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					_tmp22_ = seg;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					seg = _tmp22_ + 1;
#line 1479 "flip.c"
				}
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp20_ = FALSE;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp23_ = seg;
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				if (!(_tmp23_ < 2)) {
#line 211 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					break;
#line 1489 "flip.c"
				}
				{
					gint bit;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
					bit = 0;
#line 1495 "flip.c"
					{
						gboolean _tmp24_;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
						_tmp24_ = TRUE;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
						while (TRUE) {
#line 1502 "flip.c"
							gboolean _tmp25_;
							gint _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							GtkToggleButton* _tmp31_ = NULL;
							GtkToggleButton* t;
							GtkToggleButton* _tmp32_;
							GtkToggleButton* _tmp33_;
							GtkToggleButton** _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							gint _tmp35_;
							gint _tmp36_;
							GtkToggleButton* _tmp37_;
							GtkToggleButton* _tmp38_;
							GtkToggleButton* _tmp39_;
							gint _tmp40_;
							gint col;
							gint _tmp41_;
							gint row;
							GtkGrid* _tmp42_;
							GtkToggleButton* _tmp43_;
							gint _tmp44_;
							gint _tmp45_;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp25_ = _tmp24_;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							if (!_tmp25_) {
#line 1532 "flip.c"
								gint _tmp26_;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
								_tmp26_ = bit;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
								bit = _tmp26_ + 1;
#line 1538 "flip.c"
							}
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp24_ = FALSE;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp27_ = bit;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp28_ = self->priv->num_bits;
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							if (!(_tmp27_ < _tmp28_)) {
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
								break;
#line 1550 "flip.c"
							}
#line 213 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp29_ = seg;
#line 213 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp30_ = bit;
#line 213 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp31_ = tweak_widget_create_button (self, _tmp29_, _tmp30_);
#line 213 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							t = _tmp31_;
#line 214 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp32_ = t;
#line 214 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							gtk_widget_set_halign ((GtkWidget*) _tmp32_, GTK_ALIGN_CENTER);
#line 215 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp33_ = t;
#line 215 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							gtk_widget_set_valign ((GtkWidget*) _tmp33_, GTK_ALIGN_CENTER);
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp34_ = self->priv->toggle;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp34__length1 = self->priv->toggle_length1;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp34__length2 = self->priv->toggle_length2;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp35_ = seg;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp36_ = bit;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp37_ = t;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp38_ = _g_object_ref0 (_tmp37_);
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_g_object_unref0 (_tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_]);
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_] = _tmp38_;
#line 216 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp39_ = _tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_];
#line 217 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp40_ = seg;
#line 217 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							col = _tmp40_ * 2;
#line 218 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp41_ = bit;
#line 218 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							row = 1 + _tmp41_;
#line 219 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp42_ = grid;
#line 219 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp43_ = t;
#line 219 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp44_ = col;
#line 219 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_tmp45_ = row;
#line 219 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, _tmp44_, _tmp45_, 1, 1);
#line 212 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
							_g_object_unref0 (t);
#line 1608 "flip.c"
						}
					}
				}
			}
		}
	}
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	block2_data_unref (_data2_);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data2_ = NULL;
#line 1619 "flip.c"
}


static void ___lambda5__util_contents_delegate (GtkGrid* grid, gpointer self) {
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	__lambda5_ (self, grid);
#line 1626 "flip.c"
}


static void tweak_widget_make_dialog (TweakWidget* self) {
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GtkDialog* _tmp6_ = NULL;
#line 187 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (self != NULL);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = self->priv->full_tweak;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp1_) {
#line 1642 "flip.c"
		const gchar* _tmp2_ = NULL;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp2_ = _ ("Tweak");
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = _tmp2_;
#line 1648 "flip.c"
	} else {
		const gchar* _tmp3_ = NULL;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = _ ("Flip");
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = _tmp3_;
#line 1655 "flip.c"
	}
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = _tmp0_;
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = _ ("_OK");
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = util_make_dialog (_tmp4_, _tmp5_, ___lambda5__util_contents_delegate, self);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->dialog);
#line 188 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog = _tmp6_;
#line 1667 "flip.c"
}


/**
 * Create entries for Scale, Rotate and Move.
 */
static GtkWidget* tweak_widget_create_tweak_entries (TweakWidget* self) {
	GtkWidget* result = NULL;
	GtkGrid* _tmp0_;
	GtkGrid* grid;
	const gchar* _tmp1_ = NULL;
	GtkSpinButton* _tmp2_ = NULL;
	GtkSpinButton* _tmp3_;
	GtkSpinButton* _tmp4_;
	GtkSpinButton* _tmp5_ = NULL;
	GtkSpinButton* _tmp6_;
	GtkSpinButton* _tmp7_;
	GtkSpinButton** _tmp8_ = NULL;
	GtkSpinButton** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_ = NULL;
	GtkSpinButton* _tmp11_ = NULL;
	GtkSpinButton* _tmp12_;
	GtkSpinButton* _tmp13_;
	GtkSpinButton** _tmp14_ = NULL;
	GtkSpinButton** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_ = NULL;
	GtkSpinButton* _tmp17_ = NULL;
	GtkSpinButton* _tmp18_;
	GtkSpinButton* _tmp19_;
	GtkSpinButton* _tmp20_ = NULL;
	GtkSpinButton* _tmp21_;
	GtkSpinButton* _tmp22_;
	GtkSpinButton** _tmp23_ = NULL;
	GtkSpinButton** _tmp24_;
	gint _tmp24__length1;
#line 228 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 229 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_object_ref_sink (_tmp0_);
#line 229 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	grid = _tmp0_;
#line 230 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_grid_set_column_spacing (grid, 5);
#line 231 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_grid_set_row_spacing (grid, 5);
#line 232 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) grid, 20);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = _ ("Scale:");
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = util_make_spin_button (0.25, 2.0, 0.005);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->scale_x_entry);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->scale_x_entry = _tmp2_;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = self->priv->scale_x_entry;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = util_make_spin_button (0.25, 2.0, 0.005);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->scale_y_entry);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->scale_y_entry = _tmp5_;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = self->priv->scale_y_entry;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = g_new0 (GtkSpinButton*, 2 + 1);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_[0] = _tmp4_;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_[1] = _tmp7_;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = _tmp8_;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9__length1 = 2;
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_attach_entry (self, grid, 0, _tmp1_, _tmp9_, 2);
#line 233 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_object_unref), NULL);
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = _ ("Rotate:");
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = util_make_spin_button ((gdouble) 0, (gdouble) 360, 0.5);
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->rotate_entry);
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->rotate_entry = _tmp11_;
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = self->priv->rotate_entry;
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = g_new0 (GtkSpinButton*, 1 + 1);
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_[0] = _tmp13_;
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = _tmp14_;
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15__length1 = 1;
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_attach_entry (self, grid, 1, _tmp10_, _tmp15_, 1);
#line 235 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_object_unref), NULL);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = _ ("Move:");
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp17_ = util_make_spin_button (-1.0, 1.0, 0.005);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->move_x_entry);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->move_x_entry = _tmp17_;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp18_ = self->priv->move_x_entry;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp20_ = util_make_spin_button (-1.0, 1.0, 0.005);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->move_y_entry);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->move_y_entry = _tmp20_;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp21_ = self->priv->move_y_entry;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp23_ = g_new0 (GtkSpinButton*, 2 + 1);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp23_[0] = _tmp19_;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp23_[1] = _tmp22_;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp24_ = _tmp23_;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp24__length1 = 2;
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_attach_entry (self, grid, 2, _tmp16_, _tmp24_, 2);
#line 236 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_object_unref), NULL);
#line 238 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = (GtkWidget*) grid;
#line 238 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 1819 "flip.c"
}


/**
 * Attach an entry. This is part of create_tweak_entries.
 */
static void ____lambda6_ (TweakWidget* self) {
	GtkSpinButton* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GtkSpinButton* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	GtkSpinButton* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	GtkSpinButton* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GtkSpinButton* _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	GtkDrawingArea* _tmp15_;
	gboolean _tmp16_;
#line 250 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = self->priv->scale_x_entry;
#line 250 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = gtk_spin_button_get_value (_tmp0_);
#line 250 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = _tmp1_;
#line 250 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_tweak.scale_x = _tmp2_;
#line 251 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = self->priv->scale_y_entry;
#line 251 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = gtk_spin_button_get_value (_tmp3_);
#line 251 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = _tmp4_;
#line 251 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_tweak.scale_y = _tmp5_;
#line 252 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = self->priv->rotate_entry;
#line 252 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = gtk_spin_button_get_value (_tmp6_);
#line 252 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = _tmp7_;
#line 252 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_tweak.rotate = _tmp8_;
#line 253 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = self->priv->move_x_entry;
#line 253 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = gtk_spin_button_get_value (_tmp9_);
#line 253 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = _tmp10_;
#line 253 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_tweak.move_x = _tmp11_;
#line 254 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = self->priv->move_y_entry;
#line 254 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = gtk_spin_button_get_value (_tmp12_);
#line 254 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = _tmp13_;
#line 254 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_tweak.move_y = _tmp14_;
#line 255 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = self->priv->segment_view;
#line 255 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp15_);
#line 256 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = self->priv->ready;
#line 256 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp16_) {
#line 1892 "flip.c"
		Tweak _tmp17_;
		Flip* _tmp18_;
		gint _tmp18__length1;
		Flip _tmp19_;
		Flip* _tmp20_;
		gint _tmp20__length1;
		Flip _tmp21_;
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp17_ = self->priv->dialog_tweak;
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp18_ = self->priv->dialog_flip;
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp18__length1 = self->priv->dialog_flip_length1;
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp19_ = _tmp18_[0];
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp20_ = self->priv->dialog_flip;
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp20__length1 = self->priv->dialog_flip_length1;
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp21_ = _tmp20_[1];
#line 257 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		tweak_widget_set_tweaks (self, &_tmp17_, _tmp19_, _tmp21_);
#line 1916 "flip.c"
	}
}


static void _____lambda6__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
#line 249 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	____lambda6_ (self);
#line 1924 "flip.c"
}


static void tweak_widget_attach_entry (TweakWidget* self, GtkGrid* grid, gint y, const gchar* label_text, GtkSpinButton** buttons, int buttons_length1) {
	const gchar* _tmp0_;
	gint x;
	GtkSpinButton** _tmp6_;
	gint _tmp6__length1;
#line 244 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (self != NULL);
#line 244 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (grid != NULL);
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = label_text;
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp0_ != NULL) {
#line 1941 "flip.c"
		GtkGrid* _tmp1_;
		const gchar* _tmp2_;
		GtkLabel* _tmp3_ = NULL;
		GtkLabel* _tmp4_;
		gint _tmp5_;
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp1_ = grid;
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp2_ = label_text;
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = util_label (_tmp2_);
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp4_ = _tmp3_;
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp5_ = y;
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		gtk_grid_attach (_tmp1_, (GtkWidget*) _tmp4_, 0, _tmp5_, 1, 1);
#line 245 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_g_object_unref0 (_tmp4_);
#line 1961 "flip.c"
	}
#line 246 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	x = 1;
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = buttons;
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6__length1 = buttons_length1;
#line 1969 "flip.c"
	{
		GtkSpinButton** button_collection = NULL;
		gint button_collection_length1 = 0;
		gint _button_collection_size_ = 0;
		gint button_it = 0;
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		button_collection = _tmp6_;
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		button_collection_length1 = _tmp6__length1;
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		for (button_it = 0; button_it < _tmp6__length1; button_it = button_it + 1) {
#line 1981 "flip.c"
			GtkSpinButton* _tmp7_;
			GtkSpinButton* button = NULL;
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			_tmp7_ = _g_object_ref0 (button_collection[button_it]);
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
			button = _tmp7_;
#line 1988 "flip.c"
			{
				GtkGrid* _tmp8_;
				GtkSpinButton* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				GtkSpinButton* _tmp12_;
#line 248 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp8_ = grid;
#line 248 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp9_ = button;
#line 248 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp10_ = x;
#line 248 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				x = _tmp10_ + 1;
#line 248 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp11_ = y;
#line 248 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, _tmp10_, _tmp11_, 1, 1);
#line 249 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_tmp12_ = button;
#line 249 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				g_signal_connect_object (_tmp12_, "value-changed", (GCallback) _____lambda6__gtk_spin_button_value_changed, self, 0);
#line 247 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
				_g_object_unref0 (button);
#line 2013 "flip.c"
			}
		}
	}
}


/**
 * Create button for toggling flip.
 * segment can be 0 or 1 (even or odd segments).
 * Possible value for bit: see Flip.is_set
 */
static Block3Data* block3_data_ref (Block3Data* _data3_) {
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return _data3_;
#line 2030 "flip.c"
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2039 "flip.c"
		TweakWidget * self;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		self = _data3_->self;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_g_object_unref0 (_data3_->button);
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_g_object_unref0 (self);
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		g_slice_free (Block3Data, _data3_);
#line 2049 "flip.c"
	}
}


static gboolean __lambda10_ (Block3Data* _data3_, cairo_t* cr) {
	TweakWidget * self;
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp4_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
#line 276 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self = _data3_->self;
#line 276 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 277 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = cr;
#line 277 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_translate (_tmp0_, 0.5 * _data3_->size, 0.5 * _data3_->size);
#line 278 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = cr;
#line 278 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_scale (_tmp1_, (gdouble) _data3_->size, (gdouble) _data3_->size);
#line 279 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = _data3_->bit;
#line 279 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp2_ == 1) {
#line 2089 "flip.c"
		cairo_t* _tmp3_;
#line 279 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = cr;
#line 279 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		cairo_rotate (_tmp3_, G_PI / 2);
#line 2095 "flip.c"
	}
#line 280 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = _data3_->bit;
#line 280 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp4_ == 2) {
#line 2101 "flip.c"
		cairo_t* _tmp5_;
#line 280 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp5_ = cr;
#line 280 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		cairo_rotate (_tmp5_, G_PI / 4);
#line 2107 "flip.c"
	}
#line 282 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = cr;
#line 282 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_move_to (_tmp6_, 0.0, -0.5);
#line 283 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = cr;
#line 283 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp7_, 0.3, -0.1);
#line 284 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = cr;
#line 284 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp8_, 0.1, -0.1);
#line 285 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = cr;
#line 285 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp9_, 0.1, 0.1);
#line 286 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = cr;
#line 286 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp10_, 0.3, 0.1);
#line 287 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = cr;
#line 287 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp11_, 0.0, 0.5);
#line 288 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = cr;
#line 288 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp12_, -0.3, 0.1);
#line 289 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = cr;
#line 289 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp13_, -0.1, 0.1);
#line 290 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = cr;
#line 290 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp14_, -0.1, -0.1);
#line 291 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = cr;
#line 291 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp15_, -0.3, -0.1);
#line 292 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = cr;
#line 292 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp16_, 0.0, -0.5);
#line 293 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp17_ = cr;
#line 293 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_fill (_tmp17_);
#line 294 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = TRUE;
#line 294 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 2161 "flip.c"
}


static gboolean ___lambda10__gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = __lambda10_ (self, cr);
#line 276 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 2170 "flip.c"
}


static void __lambda11_ (Block3Data* _data3_) {
	TweakWidget * self;
	Flip _tmp0_ = 0;
	gboolean _tmp1_;
	gboolean _tmp2_;
	Flip* _tmp13_;
	gint _tmp13__length1;
	gint _tmp14_;
	Flip _tmp15_;
	Flip _tmp16_;
	GtkDrawingArea* _tmp17_;
	gboolean _tmp18_;
#line 299 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self = _data3_->self;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = gtk_toggle_button_get_active (_data3_->button);
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = _tmp1_;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp2_) {
#line 2194 "flip.c"
		Flip* _tmp3_;
		gint _tmp3__length1;
		gint _tmp4_;
		Flip _tmp5_;
		gint _tmp6_;
		Flip _tmp7_ = 0;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3_ = self->priv->dialog_flip;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp3__length1 = self->priv->dialog_flip_length1;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp4_ = _data3_->segment;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp5_ = _tmp3_[_tmp4_];
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp6_ = _data3_->bit;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp7_ = flip_set (_tmp5_, _tmp6_);
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = _tmp7_;
#line 2215 "flip.c"
	} else {
		Flip* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_;
		Flip _tmp10_;
		gint _tmp11_;
		Flip _tmp12_ = 0;
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp8_ = self->priv->dialog_flip;
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp8__length1 = self->priv->dialog_flip_length1;
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp9_ = _data3_->segment;
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp10_ = _tmp8_[_tmp9_];
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp11_ = _data3_->bit;
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp12_ = flip_clear (_tmp10_, _tmp11_);
#line 301 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp0_ = _tmp12_;
#line 2237 "flip.c"
	}
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = self->priv->dialog_flip;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13__length1 = self->priv->dialog_flip_length1;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = _data3_->segment;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = _tmp0_;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_[_tmp14_] = _tmp15_;
#line 300 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = _tmp13_[_tmp14_];
#line 302 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp17_ = self->priv->segment_view;
#line 302 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp17_);
#line 303 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp18_ = self->priv->ready;
#line 303 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp18_) {
#line 2259 "flip.c"
		Tweak _tmp19_;
		Flip* _tmp20_;
		gint _tmp20__length1;
		Flip _tmp21_;
		Flip* _tmp22_;
		gint _tmp22__length1;
		Flip _tmp23_;
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp19_ = self->priv->dialog_tweak;
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp20_ = self->priv->dialog_flip;
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp20__length1 = self->priv->dialog_flip_length1;
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp21_ = _tmp20_[0];
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp22_ = self->priv->dialog_flip;
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp22__length1 = self->priv->dialog_flip_length1;
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp23_ = _tmp22_[1];
#line 304 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		tweak_widget_set_tweaks (self, &_tmp19_, _tmp21_, _tmp23_);
#line 2283 "flip.c"
	}
}


static void ___lambda11__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 299 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	__lambda11_ (self);
#line 2291 "flip.c"
}


static GtkToggleButton* tweak_widget_create_button (TweakWidget* self, gint segment, gint bit) {
	GtkToggleButton* result = NULL;
	Block3Data* _data3_;
	gint _tmp0_;
	gint _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkDrawingArea* image;
	Flip* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	Flip _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkToggleButton* _tmp9_;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_->_ref_count_ = 1;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_->self = g_object_ref (self);
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = segment;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_->segment = _tmp0_;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = bit;
#line 268 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_->bit = _tmp1_;
#line 269 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 269 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_object_ref_sink (_tmp2_);
#line 269 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_->button = _tmp2_;
#line 270 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_toggle_button_set_mode (_data3_->button, FALSE);
#line 271 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_container_set_border_width ((GtkContainer*) _data3_->button, (guint) 0);
#line 272 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 272 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_object_ref_sink (_tmp3_);
#line 272 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	image = _tmp3_;
#line 273 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_->size = 15;
#line 274 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_size_request ((GtkWidget*) image, _data3_->size, _data3_->size);
#line 275 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_widget_set_has_window ((GtkWidget*) image, FALSE);
#line 276 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_connect_data ((GtkWidget*) image, "draw", (GCallback) ___lambda10__gtk_widget_draw, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 295 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_button_set_image ((GtkButton*) _data3_->button, (GtkWidget*) image);
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = self->priv->flip;
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4__length1 = self->priv->flip_length1;
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = _data3_->segment;
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = _tmp4_[_tmp5_];
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = _data3_->bit;
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = flip_is_set (_tmp6_, _tmp7_);
#line 297 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	gtk_toggle_button_set_active (_data3_->button, _tmp8_);
#line 299 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_connect_data (_data3_->button, "toggled", (GCallback) ___lambda11__gtk_toggle_button_toggled, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 307 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = _g_object_ref0 (_data3_->button);
#line 307 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	result = _tmp9_;
#line 307 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (image);
#line 307 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	block3_data_unref (_data3_);
#line 307 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_data3_ = NULL;
#line 307 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	return result;
#line 2380 "flip.c"
}


/**
 * Draw an F to indicate how the segment is tweaked
 */
static void tweak_widget_draw_segment (TweakWidget* self, cairo_t* cr, Tweak* tweak, Flip flip, gdouble x, gdouble y, gdouble size) {
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	cairo_t* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	Flip _tmp16_;
	gboolean _tmp17_ = FALSE;
	Flip _tmp19_;
	gboolean _tmp20_ = FALSE;
	cairo_t* _tmp22_;
	Tweak _tmp23_;
	gdouble _tmp24_;
	Tweak _tmp25_;
	gdouble _tmp26_;
	cairo_t* _tmp27_;
	Tweak _tmp28_;
	gdouble _tmp29_;
	cairo_t* _tmp30_;
	Tweak _tmp31_;
	gdouble _tmp32_;
	Tweak _tmp33_;
	gdouble _tmp34_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	cairo_t* _tmp44_;
	cairo_t* _tmp45_;
	cairo_t* _tmp46_;
#line 313 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (self != NULL);
#line 313 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (cr != NULL);
#line 313 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_return_if_fail (tweak != NULL);
#line 314 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp0_ = cr;
#line 314 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_save (_tmp0_);
#line 316 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp1_ = cr;
#line 316 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp2_ = x;
#line 316 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp3_ = y;
#line 316 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp4_ = size;
#line 316 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp5_ = size;
#line 316 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_rectangle (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 317 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp6_ = cr;
#line 317 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_set_line_width (_tmp6_, 0.2);
#line 318 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp7_ = cr;
#line 318 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_stroke (_tmp7_);
#line 321 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp8_ = cr;
#line 321 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp9_ = x;
#line 321 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp10_ = size;
#line 321 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp11_ = y;
#line 321 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp12_ = size;
#line 321 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_translate (_tmp8_, _tmp9_ + (_tmp10_ / 2), _tmp11_ + (_tmp12_ / 2));
#line 322 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp13_ = cr;
#line 322 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp14_ = size;
#line 322 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp15_ = size;
#line 322 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_scale (_tmp13_, _tmp14_, _tmp15_);
#line 324 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp16_ = flip;
#line 324 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp17_ = flip_x (_tmp16_);
#line 324 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp17_) {
#line 2489 "flip.c"
		cairo_t* _tmp18_;
#line 324 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp18_ = cr;
#line 324 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		cairo_scale (_tmp18_, (gdouble) (-1), (gdouble) 1);
#line 2495 "flip.c"
	}
#line 325 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp19_ = flip;
#line 325 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp20_ = flip_y (_tmp19_);
#line 325 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	if (_tmp20_) {
#line 2503 "flip.c"
		cairo_t* _tmp21_;
#line 325 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		_tmp21_ = cr;
#line 325 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
		cairo_scale (_tmp21_, (gdouble) 1, (gdouble) (-1));
#line 2509 "flip.c"
	}
#line 327 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp22_ = cr;
#line 327 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp23_ = *tweak;
#line 327 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp24_ = _tmp23_.move_x;
#line 327 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp25_ = *tweak;
#line 327 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp26_ = _tmp25_.move_y;
#line 327 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_translate (_tmp22_, _tmp24_, _tmp26_);
#line 328 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp27_ = cr;
#line 328 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp28_ = *tweak;
#line 328 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp29_ = _tmp28_.rotate;
#line 328 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_rotate (_tmp27_, (_tmp29_ * G_PI) / 180);
#line 329 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp30_ = cr;
#line 329 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp31_ = *tweak;
#line 329 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp32_ = _tmp31_.scale_x;
#line 329 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp33_ = *tweak;
#line 329 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp34_ = _tmp33_.scale_y;
#line 329 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_scale (_tmp30_, _tmp32_, _tmp34_);
#line 331 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp35_ = cr;
#line 331 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_move_to (_tmp35_, -0.4, -0.4);
#line 332 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp36_ = cr;
#line 332 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp36_, 0.4, -0.4);
#line 333 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp37_ = cr;
#line 333 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp37_, 0.4, -0.2);
#line 334 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp38_ = cr;
#line 334 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp38_, -0.2, -0.2);
#line 335 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp39_ = cr;
#line 335 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp39_, -0.2, -0.1);
#line 336 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp40_ = cr;
#line 336 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp40_, 0.2, -0.1);
#line 337 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp41_ = cr;
#line 337 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp41_, 0.2, 0.1);
#line 338 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp42_ = cr;
#line 338 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp42_, -0.2, 0.1);
#line 339 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp43_ = cr;
#line 339 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp43_, -0.2, 0.4);
#line 340 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp44_ = cr;
#line 340 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_line_to (_tmp44_, -0.4, 0.4);
#line 341 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp45_ = cr;
#line 341 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_fill (_tmp45_);
#line 342 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_tmp46_ = cr;
#line 342 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	cairo_restore (_tmp46_);
#line 2591 "flip.c"
}


static void tweak_widget_class_init (TweakWidgetClass * klass) {
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	tweak_widget_parent_class = g_type_class_peek_parent (klass);
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_type_class_add_private (klass, sizeof (TweakWidgetPrivate));
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	G_OBJECT_CLASS (klass)->finalize = tweak_widget_finalize;
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	g_signal_new ("tweaked", TYPE_TWEAK_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2604 "flip.c"
}


static void tweak_widget_instance_init (TweakWidget * self) {
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv = TWEAK_WIDGET_GET_PRIVATE (self);
#line 107 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog = NULL;
#line 125 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->num_bits = 2;
#line 2615 "flip.c"
}


static void tweak_widget_finalize (GObject* obj) {
	TweakWidget * self;
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEAK_WIDGET, TweakWidget);
#line 84 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip = (g_free (self->priv->flip), NULL);
#line 86 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->icon);
#line 91 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->flip_save = (g_free (self->priv->flip_save), NULL);
#line 107 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->dialog);
#line 108 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->segment_view);
#line 109 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->scale_x_entry);
#line 110 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->scale_y_entry);
#line 111 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->rotate_entry);
#line 112 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->move_x_entry);
#line 113 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	_g_object_unref0 (self->priv->move_y_entry);
#line 118 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->dialog_flip = (g_free (self->priv->dialog_flip), NULL);
#line 124 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	self->priv->toggle = (_vala_array_free (self->priv->toggle, self->priv->toggle_length1 * self->priv->toggle_length2, (GDestroyNotify) g_object_unref), NULL);
#line 82 "/home/jaidi/project/mutiara/tiara/src/flip.vala"
	G_OBJECT_CLASS (tweak_widget_parent_class)->finalize (obj);
#line 2649 "flip.c"
}


GType tweak_widget_get_type (void) {
	static volatile gsize tweak_widget_type_id__volatile = 0;
	if (g_once_init_enter (&tweak_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TweakWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tweak_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TweakWidget), 0, (GInstanceInitFunc) tweak_widget_instance_init, NULL };
		GType tweak_widget_type_id;
		tweak_widget_type_id = g_type_register_static (GTK_TYPE_BUTTON, "TweakWidget", &g_define_type_info, 0);
		g_once_init_leave (&tweak_widget_type_id__volatile, tweak_widget_type_id);
	}
	return tweak_widget_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



